;*****************************************************
;This subroutine 
;
;*****************************************************
#include <aspic.h>

	_ind0		equ	0x00
	_status		equ	0x03
	_fsr		equ	0x04
	_porta		equ	0x0c	;ԊOLED Connected Port is A

;	_status: Xe[^X̑삷rbgݒ
	_c		equ	0
	_z		equ	2

;	_porta: A|[g̑삷rbgݒ
	_led	equ	5		; ԊOLEDRA5ɐڑ
	
;	_ScnStatus: [U[Xe[^XQ̑rbgݒ
	_carri40	equ	0		; LAgSOgtO
	_carri33	equ	1		; LAgRRgtO
	_sharp		equ	2		; ꃂ[hiV[vjtO

;*****************************************************************************
; --- iNbNAlɂύX鎖j4MHz ---
;	vl_offtime	equ	24		; Ԋ{^C}[
;	vl_ontime	equ 4		; Ԋ{^C}[ (1 = 26us)
;	vl_keywait	equ	100		; key ҂Ԋ{^C}[

; --- iNbNAlɂύX鎖j8MHz ---
	vl_offtime	equ	24		; Ԋ{^C}[
	vl_ontime	equ 4		; Ԋ{^C}[ (1 = 26us)
	vl_keywait	equ	100		; key ҂Ԋ{^C}[

;*****************************************************************************
	PSECT bss,class=BANK0,space=1	;f[^

	_count1: DS 1				; ėpJE^[P
	_count2: DS 1				; ėpJE^[Q
	_buffer1: DS 1				; ėpobt@[P
	_cntBF0: DS 1				; xԃJE^O
	_cntBF1: DS 1				; xԃJE^P

	GLOBAL _transmit;,?_transmit ; make _add globally accessible
	GLOBAL _tx_data				;
	GLOBAL _ScnStatus			; p[U[Xe[^XQ
	GLOBAL 	_rmcbyt				; MoCg
	GLOBAL _rmcbit				; M[rbg
	GLOBAL 	_start_h			; X^[gM  
	GLOBAL 	_start_l			; X^[gM  
	GLOBAL 	_data_0h			; f[^OM  
	GLOBAL 	_data_1h			; f[^PM  
	GLOBAL 	_data_0l			; f[^OM  
	GLOBAL 	_data_1l			; f[^PM  
	GLOBAL 	_stop_h				; XgbvM  

	GLOBAL 	_rptwait_bf			; s[g҂
	GLOBAL 	_rptwait			; s[g҂

	SIGNAT _transmit,8298 ; tell the linker how it should be called

;----------------------------------------------------------------------------
	; everything following will be placed into the mytext psect
	psect mytext,local,class=CODE,delta=2
	; our routine to add to ints and return the result
;----------------------------------------------------------------------------
;        	f[^𑗐M

_transmit:
;	bcf		0x8b,7			; 荞݋֎~
	movlw	_tx_data
	movwf	_fsr
	btfss	_ScnStatus,_sharp	; V[v[h
	goto	data_tx_a
	goto	data_tx_b

;******************************************************************************
;	Mɍ킵č쐬
;******************************************************************************


;-----------------------------------
;	`  ƓdW { \j[

data_tx_a:
	call	start_tx
	movf	_rmcbyt,W
	call	byt_tx
	movf	_rmcbit,W
	call	bit_tx
	call	stop_tx
;	bsf		0x8b,7	; 荞ݍĊJ
	return

;-----------------------------------
;	aV[v

data_tx_b:
	movf	_rmcbyt,W		; PubNM
	call	byt_tx
	movf	_rmcbit,W
	call	bit_tx
	call	stop_tx

	movf	_rptwait_bf,W		; s[g҂
	movwf	_rptwait
data_tx_b_01:
	movlw	vl_keywait
	call	wait_lo
	decfsz	_rptwait,F
	goto	data_tx_b_01

	movf	_rmcbyt,W		; QubNM
	call	byt_tx
	movf	_rmcbit,W
	call	bit_tx
	call	stop_tx
;	bsf		0x8b,7	; 荞ݍĊJ
	return


;******************************************************************************


;---------------------------------------
;	X^[grbgM

start_tx:
	movf	_start_h,W		; X^[gM  
	btfsc	_status,_z		; X^[grbgL`FbN
	return

	movf	_start_h,W		; X^[gM  ԃZbg
	call	wait_hi
	movf	_start_l,W		; X^[gM  ԃZbg
	call	wait_lo
	return


;---------------------------------------
;	oCgf[^M
byt_tx:
	movwf	_count2
byt_tx_01:
	movlw	8
	movwf	_count1
	movf	_ind0,W
	movwf	_buffer1
byt_tx_02:
	bcf	_status,_c
	rrf	_buffer1,F
	btfsc	_status,_c
	goto	byt_tx_04

; --- rbgf[^O ---
byt_tx_03:
	movf	_data_0h,W		; f[^OM  ԃZbg
	call	wait_hi
	movf	_data_0l,W		; f[^OM  ԃZbg
	call	wait_lo
	goto	byt_tx_05

; --- rbgf[^P ---
byt_tx_04:
	movf	_data_1h,W		; f[^PM  ԃZbg
	call	wait_hi
	movf	_data_1l,W		; f[^PM  ԃZbg
	call	wait_lo

byt_tx_05
	decfsz	_count1,F
	goto	byt_tx_02
	incf	_fsr,F
	decfsz	_count2,F
	goto	byt_tx_01
	return


;----------------------------------------
;	rbgf[^M

bit_tx:
	movwf	_count1
	movf	_count1,W
	btfsc	_status,_z
	return

	movf	_ind0,W
	movwf	_buffer1
bit_tx_01:
	bcf	_status,_c
	rrf	_buffer1,F
	btfsc	_status,_c
	goto	bit_tx_03

; --- rbgf[^O ---
bit_tx_02:
	movf	_data_0h,W		; f[^OM  ԃZbg
	call	wait_hi
	movf	_data_0l,W		; f[^OM  ԃZbg
	call	wait_lo
	goto	bit_tx_04

; --- rbgf[^P ---
bit_tx_03:
	movf	_data_1h,W		; f[^PM  ԃZbg
	call	wait_hi
	movf	_data_1l,W		; f[^PM  ԃZbg
	call	wait_lo

bit_tx_04:
	decfsz	_count1,F
	goto	bit_tx_01
	incf	_fsr,F
	return


;---------------------------------------
;	XgbvM

stop_tx:
	movf	_stop_h,W
	btfsc	_status,_z		; XgbvrbgL`FbN
	return
	movf	_stop_h,W		; XgbvM  ԃZbg
	call	wait_hi
	return


;----------------------------------------------------------------------------
;	҂

; --- LED҂ԁi荞ݕsv^CvSlgj ---
;	LAROʂiRRgjCLAQUʂiRWgj
;	LAQTʂiSOgj

wait_hi:
	movwf	_cntBF1			; pX(1 = 0.1ms)
wait_hi_01:
	movlw	vl_ontime		; 1
	movwf	_cntBF0			; 1
wait_hi_02:
	bsf	_porta,_led		; (LED on)
	btfsc	_ScnStatus,_carri33	; 1 | 2      
	goto	wait_hi_05		; 5 | 0      
	goto	$ + 1			; 0 | 2      
wait_hi_03:
	goto	$ + 1			;     2      
	goto	$ + 1			;     2      
	nop				;     1      
	btfss	_ScnStatus,_carri40	;     1 | 2  
	goto	$ + 1			;     2 | 0  
	bcf	_porta,_led		; 15|13 | 12  (LED off)
	btfsc	_ScnStatus,_carri33	; 1 |   2      
	goto	wait_hi_06		; 5 |   0      
	goto	$ + 1			; 0 |   2
wait_hi_04:
	nop				;       1      
	decfsz	_cntBF0,F		;     1 | 2    
	goto	wait_hi_07		;     6 | 0    
	decfsz	_cntBF1,F		;         1 | 2
	goto	wait_hi_01		;         4
	return			      ;;; 15|13  15|13 (LED on)

wait_hi_05:
	nop				; 1
	goto	wait_hi_03		; 2

wait_hi_06:
	nop				; 1
	goto	wait_hi_04		; 2

wait_hi_07:
	goto	$ + 1			; 2
	goto	wait_hi_02		; 2



; --- LED҂ ---
wait_lo:
	movwf	_cntBF1		; pX(1 = 0.1ms)
wait_lo_01:
	movlw	vl_offtime
	movwf	_cntBF0
wait_lo_02
	nop
	decfsz	_cntBF0,F
	goto	wait_lo_02
	decfsz	_cntBF1,F
	goto	wait_lo_01
	return


